From d58eaafd5a5bcbe39a574d4bdff3771ae9ced2ed Mon Sep 17 00:00:00 2001
From: Chris Lamb <chris@chris-lamb.co.uk>
Date: Thu, 31 Jul 2008 17:12:06 +0100
Subject: Add lh_chroot_local-patches helper to apply local patches against
 chroot.

---
 helpers/lh_chroot               |  1 +
 helpers/lh_chroot_local-patches | 70 +++++++++++++++++++++++++++++++++++++++++
 helpers/lh_config               |  1 +
 3 files changed, 72 insertions(+)
 create mode 100755 helpers/lh_chroot_local-patches

diff --git a/helpers/lh_chroot b/helpers/lh_chroot
index 7dee5b3..7a527be 100755
--- a/helpers/lh_chroot
+++ b/helpers/lh_chroot
@@ -54,6 +54,7 @@ lh_chroot_local-packages ${*}
 lh_chroot_install-packages ${*}
 lh_chroot_localization ${*}
 lh_chroot_local-includes ${*}
+lh_chroot_local-patches ${*}
 lh_chroot_sysvinit ${*}
 lh_chroot_local-hooks ${*}
 lh_chroot_hooks ${*}
diff --git a/helpers/lh_chroot_local-patches b/helpers/lh_chroot_local-patches
new file mode 100755
index 0000000..caa6180
--- /dev/null
+++ b/helpers/lh_chroot_local-patches
@@ -0,0 +1,70 @@
+#!/bin/sh
+
+# lh_chroot_local-patches(1) - apply local patches against chroot
+# Copyright (C) 2006-2008 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+LH_BASE="${LH_BASE:-/usr/share/live-helper}"
+
+for FUNCTION in "${LH_BASE}"/functions/*.sh
+do
+	. "${FUNCTION}"
+done
+
+# Setting static variables
+DESCRIPTION="apply local patches against chroot"
+HELP=""
+USAGE="${PROGRAM} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffile config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+Echo_message "Begin applying chroot local patches..."
+
+# Requiring stage file
+Require_stagefile .stage/bootstrap
+
+# Checking stage file
+Check_stagefile .stage/chroot_local-patches
+
+# Checking lock file
+Check_lockfile .lock
+
+# Creating lock file
+Create_lockfile .lock
+
+if ls -A config/chroot_local-patches/ | grep -qs .
+then
+	# Restoring cache
+	Restore_cache cache/packages_chroot
+
+	# Checking depends
+	Check_package chroot/usr/bin/patch patch
+
+	# Installing depends
+	Install_package
+
+	for PATCH in config/chroot_local-patches/*
+	do
+		Echo_message "Applying patch ${PATCH}..."
+		Chroot "patch -p1" < ${PATCH}
+	done
+
+	# Removing depends
+	Remove_package
+
+	# Saving cache
+	Save_cache cache/packages_chroot
+
+	# Creating stage file
+	Create_stagefile .stage/chroot_local-patches
+fi
diff --git a/helpers/lh_config b/helpers/lh_config
index 310c7ca..3d09aba 100755
--- a/helpers/lh_config
+++ b/helpers/lh_config
@@ -874,6 +874,7 @@ EOF
 mkdir -p config/chroot_apt
 mkdir -p config/chroot_local-hooks
 mkdir -p config/chroot_local-includes
+mkdir -p config/chroot_local-patches
 mkdir -p config/chroot_local-packages
 mkdir -p config/chroot_local-packageslists
 mkdir -p config/chroot_local-preseed
-- 
cgit v1.0